var handleStackTrace = function (eStack) {
    if (eStack === void 0) { eStack = ""; }
    if (!eStack || typeof eStack !== "string") {
        return [];
    }
    var arr = eStack
        .split("\n") // split between stack lines
        .map(function (i) { return i.trim(); }) // remove the emplty spaces at the begining
        .slice(1); // removes the error message
    var res = [];
    // * Stack trace limits in nodejs is 10. so lenght is <= 10
    for (var i = 0; i < arr.length; i++) {
        // * The main fx is test(). when we reach it, stop the loop
        if (arr[i].startsWith("at test")) {
            break;
        }
        var currStrArr = arr[i].split(" ");
        var lineStr = currStrArr[currStrArr.length - 1];
        if (lineStr.startsWith("(")) {
            lineStr = lineStr.slice(1);
        }
        if (lineStr.endsWith(")")) {
            lineStr = lineStr.slice(0, -1);
        }
        var lineStrArr = lineStr.split(":");
        var line = lineStrArr[lineStrArr.length - 2];
        var col = lineStrArr[lineStrArr.length - 1];
        res.push("".concat(currStrArr[1], " on line: ").concat(line, ", col: ").concat(col));
    }
    return res;
};
/**
 *
 * @param {Error} error Error
 * @returns {object}
 */
var getErrorInfo = function (error) {
    var errors = [];
    if (!(error instanceof Error)) {
        errors.push("error is not defined");
        return errors;
    }
    var stack = handleStackTrace(error.stack);
    errors.push(error.toString());
    errors.push.apply(errors, stack);
    return errors;
};
export default getErrorInfo;
