import { existsSync, readFileSync, readdirSync, statSync } from "fs.js";
import { join } from "path.js";
export default (function (projectPath) {
    var uInfo = null;
    try {
        if (existsSync(projectPath) && statSync(projectPath).isDirectory()) {
            var files = readdirSync(projectPath);
            var readme = files.find(function (f) { return /^readme.md$/i.test(f); });
            if (readme) {
                var readmePath = join(projectPath, readme);
                var content = readFileSync(readmePath, "utf-8").toString();
                if (content) {
                    uInfo = {};
                    var matchs = content.match(/http.+github.[a-z]+\/[a-z0-9-_\/]+/gim);
                    if (matchs === null || matchs === void 0 ? void 0 : matchs.length) {
                        var repoUrl = matchs.find(function (i) { return i.includes("github.com"); });
                        if (repoUrl)
                            uInfo.repoUrl = repoUrl;
                        var demoUrl = matchs.find(function (i) { return i.includes("github.io"); });
                        if (demoUrl)
                            uInfo.demoUrl = demoUrl;
                    }
                    if (uInfo.repoUrl) {
                        var repoM = uInfo.repoUrl.match(/http.+github.com\/[a-z0-9-_]+/gi);
                        if (repoM === null || repoM === void 0 ? void 0 : repoM[0])
                            uInfo.github = repoM[0];
                    }
                    if (uInfo.demoUrl && !uInfo.github) {
                        var uMatch2 = uInfo.demoUrl.match(/[a-z0-9-_]+.github.io/gi);
                        if (uMatch2 === null || uMatch2 === void 0 ? void 0 : uMatch2[0]) {
                            var username = uMatch2[0].slice(0, -".github.io".length);
                            uInfo.github = "https://github.com/".concat(username);
                        }
                    }
                }
            }
        }
    }
    catch (error) { }
    return uInfo;
});
