const handleStackTrace = (eStack = "") => {
  if (!eStack || typeof eStack !== "string") {
    return [];
  }
  let arr = eStack
    .split("\n") // split between stack lines
    .map((i) => i.trim()) // remove the emplty spaces at the begining
    .slice(1); // removes the error message

  let res = [];

  // * Stack trace limits in nodejs is 10. so lenght is <= 10
  for (let i = 0; i < arr.length; i++) {
    // * The main fx is test(). when we reach it, stop the loop
    if (arr[i].startsWith("at test")) {
      break;
    }
    let currStrArr = arr[i].split(" ");
    let lineStr = currStrArr[currStrArr.length - 1];
    if (lineStr.startsWith("(")) {
      lineStr = lineStr.slice(1);
    }
    if (lineStr.endsWith(")")) {
      lineStr = lineStr.slice(0, -1);
    }
    let lineStrArr = lineStr.split(":");
    let line = lineStrArr[lineStrArr.length - 2];
    let col = lineStrArr[lineStrArr.length - 1];
    res.push(`${currStrArr[1]} on line: ${line}, col: ${col}`);
  }

  return res;
};

/**
 *
 * @param {Error} error Error
 * @returns {object}
 */
const getErrorInfo = (error: any) => {
  const errors = [];
  if (!(error instanceof Error)) {
    errors.push("error is not defined");
    return errors;
  }
  const stack = handleStackTrace(error.stack);
  errors.push(error.toString());
  errors.push(...stack);
  return errors;
};

export default getErrorInfo;
