interface MadeI {
  name: string;
  meta: {};
  type: string;
}

interface FileI extends MadeI {
  type: "file";
}

export type NodeI = FolderI | FileI;

export interface FolderI extends MadeI {
  children: NodeI[];
  type: "directory";
}

export const mkfile = (name: string, meta = {}): FileI => ({
  name,
  meta,
  type: "file",
});

export const mkdir = (
  name: string,
  children?: (FileI | FolderI)[],
  meta = {}
): FolderI => ({
  name,
  children: children || [],
  meta,
  type: "directory",
});

export const getChildren = (directory: FolderI) => directory.children;

export const getMeta = (node: NodeI) => node.meta;

export const getName = (node: NodeI) => node.name;

export const isFile = (node: NodeI) => node.type === "file";

export const isDirectory = (node: NodeI) => node.type === "directory";

// const map = (callbackFn, tree) => {
//   const updatedNode = callbackFn(tree);

//   return isDirectory(tree)
//     ? { ...updatedNode, children: tree.children.map((n) => map(callbackFn, n)) }
//     : updatedNode;
// };

// const reduce = (callbackFn, tree, acc) => {
//   const newAcc = callbackFn(acc, tree);

//   if (isFile(tree)) {
//     return newAcc;
//   }
//   return tree.children.reduce((iAcc, n) => reduce(callbackFn, n, iAcc), newAcc);
// };

// const filter = (callbackFn, tree) => {
//   if (!callbackFn(tree)) {
//     return null;
//   }

//   return isDirectory(tree)
//     ? {
//         ...tree,
//         children: tree.children
//           .map((n) => filter(callbackFn, n))
//           .filter((v) => v),
//       }
//     : tree;
// };
